/* 
 * Proview   $Id: cnv_wbltohtml.cpp,v 1.18 2008-10-31 12:51:30 claes Exp $
 * Copyright (C) 2005 SSAB Oxelsund AB.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation, either version 2 of 
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with the program, if not, write to the Free Software 
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */



#include <iostream>
#include <fstream>
#include <vector>
#include <float.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "cnv_wbltohtml.h"
#include "cnv_wbltoh.h"
#include "cnv_readsrc.h"
extern "C" {
#include "pwr.h"
#include "co_cdh.h"
#include "co_time.h"
#include "co_dcli.h"
}
#include "co_lng.h"

int CnvWblToHtml::init( char *first)
{
  pwr_tFileName fname;
  pwr_tFileName gname;
  char allclasses_name[80];
  char timestr[80];

  time_AtoAscii( 0, time_eFormat_DateAndTime, timestr, sizeof(timestr));
  strcpy( html_first, ctx->rw->volume_name);
  strcat( html_first, "_");
  strcat( html_first, first);
  cdh_ToLower( html_first, html_first);

  strcpy( allclasses_name, ctx->rw->volume_name);
  strcat( allclasses_name, "_allclasses.html");
  cdh_ToLower( allclasses_name, allclasses_name);

  // Create index file
  {
    strcpy( fname, ctx->dir);
    strcat( fname, ctx->rw->volume_name);
    strcat( fname, "_index.html");
    cdh_ToLower( fname, fname);

    ofstream fp( fname);

    // Get group menu name
    if ( ctx->setup->group_cnt) {
      strcpy( gname, CnvCtx::low(ctx->rw->volume_name));
      strcat( gname, "_menu_group.html");
      cdh_ToLower( fname, fname);
    }

    fp <<
"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\"\"http://www.w3.org/TR/REC-html40/loose.dtd>" << endl <<
"<!-- Generated by co_convert " << timestr << "  -->" << endl <<
"<HTML>" << endl <<
"<HEAD>" << endl <<
"<META http-equiv=\"Content-Type\" content=\"text/html; charset=ISO-8859-1\">" << endl <<
"<TITLE>" << endl <<
"Class Menu" << endl <<
"</TITLE>" << endl <<
"<link rel=\"stylesheet\" type=\"text/css\" href=\"orm.css\">" << endl <<
"</HEAD>" << endl <<
"<FRAMESET cols=\"20%,80%\">" << endl;
    if ( ctx->setup->group_cnt)
      fp <<
"<FRAMESET rows=\"20%,80%\">" << endl <<
"<FRAME src=\"" << gname << "\" name=\"groupFrame\">" << endl <<
"<FRAME src=\"" << allclasses_name << "\" name=\"menuFrame\">" << endl <<
"</FRAMESET>" << endl;
    else
      fp <<
"<FRAME src=\"" << allclasses_name << "\" name=\"menuFrame\">" << endl;
      
    fp <<
"<FRAME src=\"" << html_first << ".html\" name=\"classFrame\">" << endl <<
"</FRAMESET>" << endl <<
"<NOFRAMES>" << endl <<
"<H2>" << endl <<
"Frame Alert</H2>" << endl <<

"<P>" << endl <<
"This document is designed to be viewed using the frames feature. If you see this message, you are using a non-frame-capable web client." << endl <<
"<BR>" << endl <<
"Link to <A HREF=\"" << html_first << ".html\">Non-frame version.</A></NOFRAMES>" << endl <<
"</HTML>" << endl;
  }


  // Create js index file
  strcpy( fname, ctx->dir);
  strcat( fname, ctx->rw->volume_name);
  strcat( fname, "_allclasses.jsf");
  cdh_ToLower( fname, fname);

  fp_js_all.open( fname);
  js_all_first = true;
  fp_js_all <<
"function " << ctx->rw->volume_name << "_AllClasses( parent)" << endl <<
"{" << endl << 
"parent.addChildren([" << endl;

  // Create group menu file 
  if ( ctx->setup->group_cnt) {
    strcpy( fname, ctx->dir);
    strcat( fname, gname);
    cdh_ToLower( fname, fname);

    ofstream fp( fname);


    fp <<
"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Frameset//EN\"\"http://www.w3.org/TR/REC-html40/frameset.dtd\">" << endl <<
"<!-- Generated by co_convert " << timestr << "  -->" << endl <<
"<HTML>" << endl <<
"<HEAD>" << endl <<
"<META http-equiv=\"Content-Type\" content=\"text/html; charset=ISO-8859-1\">" << endl <<
"<TITLE>" << endl <<
"Groups" << endl <<
"</TITLE>" << endl <<
"<link rel=\"stylesheet\" type=\"text/css\" href=\"orm.css\">" << endl <<
"</HEAD>" << endl <<
"<BODY BGCOLOR=\"white\">" << endl <<
"<FONT size=\"+1\" CLASS=\"FrameHeadingFont\">" << endl <<
"<B>Groups</B></FONT>" << endl <<
"<BR>" << endl <<
"" << endl <<
"<TABLE BORDER=\"0\" WIDTH=\"100%\">" << endl <<
"<TR>" << endl <<
"<TD NOWRAP><FONT CLASS=\"FrameItemFont\">  " << endl;

    // Put index filename in fname
    strcpy( fname, ctx->rw->volume_name);
    strcat( fname, "_index.html");
    cdh_ToLower( fname, fname);

    fp <<
"<A HREF=\"" << fname << "\" TARGET=\"_parent\">AllClasses</A>" << endl <<
"<BR>" << endl;
  
    for ( int i = 0; i < ctx->setup->group_cnt; i++) {
      // Put group index filename in fname
      strcpy( fname, ctx->rw->volume_name);
      strcat( fname, "_group_");
      strcat( fname, ctx->setup->groups[i]);
      strcat( fname, "_index.html");
      cdh_ToLower( fname, fname);

      fp <<
"<A HREF=\"" << fname << "\" TARGET=\"_parent\">" << ctx->setup->groups[i] << "</A>" << endl <<
"<BR>" << endl;
    }

    fp <<
"</FONT></TD>" << endl <<
"</TR>" << endl <<
"</TABLE>" << endl <<
"" << endl <<
"</BODY>" << endl <<
"</HTML>" << endl;

  }

  // Open allclasses file
  strcpy( fname, ctx->dir);
  strcat( fname, allclasses_name);
  cdh_ToLower( fname, fname);
  fp_html_index.open( fname);


  html_index_open = 1;

  fp_html_index <<
"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Frameset//EN\"\"http://www.w3.org/TR/REC-html40/frameset.dtd\">" << endl <<
"<!-- Generated by co_convert " << timestr << "  -->" << endl <<
"<HTML>" << endl <<
"<HEAD>" << endl <<
"<META http-equiv=\"Content-Type\" content=\"text/html; charset=ISO-8859-1\">" << endl <<
"<TITLE>" << endl <<
"All Classes" << endl <<
"</TITLE>" << endl <<
"<link rel=\"stylesheet\" type=\"text/css\" href=\"orm.css\">" << endl <<
"</HEAD>" << endl <<
"<BODY BGCOLOR=\"white\">" << endl <<
"<FONT size=\"+1\" CLASS=\"FrameHeadingFont\">" << endl <<
"<B>All Classes</B></FONT>" << endl <<
"<BR>" << endl <<
"" << endl <<
"<TABLE BORDER=\"0\" WIDTH=\"100%\">" << endl <<
"<TR>" << endl <<
"<TD NOWRAP><FONT CLASS=\"FrameItemFont\">  " << endl;

  // Open one index file for each configured group
  for ( int i = 0; i < ctx->setup->group_cnt; i++) {

    // Create index page for each group
    strcpy( fname, ctx->dir);
    strcat( fname, ctx->rw->volume_name);
    strcat( fname, "_group_");
    strcat( fname, ctx->setup->groups[i]);
    strcat( fname, "_index.html");
    cdh_ToLower( fname, fname);
    {
      ofstream fp( fname);

      // Put menu filename in fname
      strcpy( fname, ctx->rw->volume_name);
      strcat( fname, "_group_");
      strcat( fname, ctx->setup->groups[i]);
      strcat( fname, ".html");
      cdh_ToLower( fname, fname);

      fp <<
"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\"\"http://www.w3.org/TR/REC-html40/loose.dtd>" << endl <<
"<!-- Generated by co_convert " << timestr << "  -->" << endl <<
"<HTML>" << endl <<
"<HEAD>" << endl <<
"<META http-equiv=\"Content-Type\" content=\"text/html; charset=ISO-8859-1\">" << endl <<
"<TITLE>" << endl <<
"Group Menu" << endl <<
"</TITLE>" << endl <<
"<link rel=\"stylesheet\" type=\"text/css\" href=\"orm.css\">" << endl <<
"</HEAD>" << endl <<
"<FRAMESET cols=\"20%,80%\">" << endl <<
"<FRAMESET rows=\"20%,80%\">" << endl <<
"<FRAME src=\"" << gname << "\" name=\"groupFrame\">" << endl <<
"<FRAME src=\"" << fname << "\" name=\"menuFrame\">" << endl <<
"</FRAMESET>" << endl;
      if ( strcmp( ctx->setup->groups_startpage[i], "") == 0)
	fp <<
"<FRAME name=\"classFrame\">" << endl;
      else
	fp <<
"<FRAME src=\"" << ctx->setup->groups_startpage[i] << "\" name=\"classFrame\">" << endl;

      fp <<
"</FRAMESET>" << endl <<
"<NOFRAMES>" << endl <<
"<H2>" << endl <<
"Frame Alert</H2>" << endl <<

"<P>" << endl <<
"This document is designed to be viewed using the frames feature. If you see this message, you are using a non-frame-capable web client." << endl <<
"<BR>" << endl <<
"Link to <A HREF=\"" << html_first << ".html\">Non-frame version.</A></NOFRAMES>" << endl <<
"</HTML>" << endl;

    }

    // Create menu page
    strcpy( fname, ctx->dir);
    strcat( fname, ctx->rw->volume_name);
    strcat( fname, "_group_");
    strcat( fname, ctx->setup->groups[i]);
    strcat( fname, ".html");
    cdh_ToLower( fname, fname);
    fp_html_group[i].open( fname);

    strcpy( fname, ctx->dir);
    strcat( fname, ctx->rw->volume_name);
    strcat( fname, "_group_");
    strcat( fname, ctx->setup->groups[i]);
    strcat( fname, ".jsf");
    cdh_ToLower( fname, fname);
    fp_js_group[i].open( fname);

    fp_html_group[i] <<
"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Frameset//EN\"\"http://www.w3.org/TR/REC-html40/frameset.dtd\">" << endl <<
"<!-- Generated by co_convert " << timestr << "  -->" << endl <<
"<HTML>" << endl <<
"<HEAD>" << endl <<
"<META http-equiv=\"Content-Type\" content=\"text/html; charset=ISO-8859-1\">" << endl <<
"<TITLE>" << endl <<
ctx->setup->groups[i] << endl <<
"</TITLE>" << endl <<
"<link rel=\"stylesheet\" type=\"text/css\" href=\"orm.css\">" << endl <<
"</HEAD>" << endl <<
"<BODY BGCOLOR=\"white\">" << endl <<
"<FONT size=\"+1\" CLASS=\"FrameHeadingFont\">" << endl <<
"<B>" << ctx->setup->groups[i] << "</B></FONT>" << endl <<
"<BR>" << endl <<
"" << endl <<
"<TABLE BORDER=\"0\" WIDTH=\"100%\">" << endl <<
"<TR>" << endl <<
"<TD NOWRAP><FONT CLASS=\"FrameItemFont\">  " << endl;


    js_group_first[i] = true;
    fp_js_group[i] <<
      "function " << ctx->rw->volume_name << "_" << ctx->setup->groups[i] << "(parent)" << endl <<
      "{" << endl <<
      "parent.addChildren([" << endl;

  }

  // Create js map for volume
  {
    strcpy( fname, ctx->dir);
    strcat( fname, ctx->rw->volume_name);
    strcat( fname, "_groups.jsf");
    cdh_ToLower( fname, fname);
    ofstream fp( fname);
 
   fp <<
"function " << ctx->rw->volume_name << "(parent)" << endl <<
"{" << endl <<
"  aux = insFld(parent, gFld(\"AllClasses\",\"" << ctx->rw->volume_name << "_index.html\"))" << endl <<
"  " << ctx->rw->volume_name << "_AllClasses(aux)" << endl;

    for ( int i = 0; i < ctx->setup->group_cnt; i++) {
      strcpy( fname, ctx->rw->volume_name);
      strcat( fname, "_group_");
      strcat( fname, ctx->setup->groups[i]);
      strcat( fname, "_index.html");
      cdh_ToLower( fname, fname);

      fp <<
"  aux = insFld(parent, gFld(\"" << ctx->setup->groups[i] << "\",\"" << fname << "\"))" << endl <<
"  " << ctx->rw->volume_name << "_" << ctx->setup->groups[i] << "(aux)" << endl;
    }
    fp << 
"}" << endl;
  }
    
  return 1;
}

int CnvWblToHtml::close()
{

  fp_html_index <<
"</FONT></TD>" << endl <<
"</TR>" << endl <<
"</TABLE>" << endl <<
"" << endl <<
"</BODY>" << endl <<
"</HTML>" << endl;
  fp_html_index.close();

  print_all_menu();

  fp_js_all << 
"])" << endl <<
"}" << endl;
  fp_js_all.close();

  for ( int i = 0; i < ctx->setup->group_cnt; i++) {
    fp_html_group[i] <<
"</FONT></TD>" << endl <<
"</TR>" << endl <<
"</TABLE>" << endl <<
"" << endl <<
"</BODY>" << endl <<
"</HTML>" << endl;
    fp_html_group[i].close();

    fp_js_group[i] <<
"])" << endl <<
"}" << endl;
    fp_js_group[i].close();
  }

#if 0
  {
    char fname[200];

    strcpy( fname, ctx->dir);
    strcat( fname, "index.jsm");
    cdh_ToLower( fname, fname);
    ofstream fp( fname);
 
   fp <<
"  aux = insFld(foldersTree, gFld(\"<b>pwrs</b>\",\"pwrs_index.html\"))" << endl <<
"  pwrs_index(aux)" << endl <<
"  aux = insFld(foldersTree, gFld(\"<b>pwrb</b>\",\"pwrb_index.html\"))" << endl <<
"  pwrb_index(aux)" << endl <<
"  aux = insFld(foldersTree, gFld(\"<b>nmps</b>\",\"nmps_index.html\"))" << endl <<
"  nmps_index(aux)" << endl <<
"  aux = insFld(foldersTree, gFld(\"<b>ssab</b>\",\"ssab_index.html\"))" << endl <<
"  ssab_index(aux)" << endl <<
"  aux = insFld(foldersTree, gFld(\"<b>tlog/b>\",\"tlog_index.html\"))" << endl <<
"  tlog_index(aux)" << endl;

   fp.close();
  }
#endif

  char cmd[400];
  sprintf( cmd, "cat %s/*.jsf %s/../../orm_menu.js > %s/menu.js", ctx->dir, 
	   ctx->dir, ctx->dir);
  system( cmd);

  return 1;
}

int CnvWblToHtml::class_exec()
{
  pwr_tFileName fname;
  int i;
  pwr_tFileName html_file_name;
  pwr_tFileName ctree_file;
  char full_class_name[80];
  char ref_name[200];
  pwr_tFileName struct_file;
  pwr_tFileName hpp_file;
  char low_volume_name[80];
  char low_class_name[80];
  char txt[200];
  char timestr[80];
  int lng_sts = 1;

  cdp_created = false;

  if ( Lng::current() != lng_eLanguage_en_US)
    lng_sts = ctx->rw->read_lng( ctx->rw->class_name, 0);

  time_AtoAscii( 0, time_eFormat_DateAndTime, timestr, sizeof(timestr));

  cdh_ToLower( low_volume_name, ctx->rw->volume_name);
  cdh_ToLower( low_class_name, ctx->rw->class_name);

  CnvWblToH::get_filename( ctx->rw, fname, 0);
  CnvReadSrc::filename_to_html( struct_file, fname);

  ctx->hpp = 1;
  CnvWblToH::get_filename( ctx->rw, fname, 1);
  CnvReadSrc::filename_to_html( hpp_file, fname);
  ctx->hpp = 0;

  strcpy( full_class_name, ctx->rw->volume_name);
  strcat( full_class_name, ":");
  strcat( full_class_name, ctx->rw->class_name);

  strcpy( html_file_name, low_volume_name);
  strcat( html_file_name, "_");
  strcat( html_file_name, low_class_name);

  strcpy( ctree_file, low_volume_name);
  strcat( ctree_file, "_");
  strcat( ctree_file, low_class_name);
  strcat( ctree_file, "_ctree.html");


  // Add into index file
  fp_html_index <<
"<A HREF=\"" << html_file_name << ".html\" TARGET=\"classFrame\">" << ctx->rw->class_name << "</A>" << endl <<
"<BR>" << endl;

  cnv_mentry mentry;
  strcpy( mentry.name, ctx->rw->class_name);
  strcpy( mentry.file, html_file_name);
  strcat( mentry.file, ".html");
  all_classes.push_back( mentry);

  // Add into group file
  for ( int i = 0; i < ctx->rw->doc_group_cnt; i++) {
    for ( int j = 0; j < ctx->setup->group_cnt; j++) {
      if ( cdh_NoCaseStrcmp( ctx->rw->doc_groups[i], ctx->setup->groups[j]) == 0) {
	fp_html_group[j] <<
"<A HREF=\"" << html_file_name << ".html\" TARGET=\"classFrame\">" << ctx->rw->class_name << "</A>" << endl <<
"<BR>" << endl;

 	if ( !js_group_first[j])
	  fp_js_group[j] << ",";
	else
	  js_group_first[j] = false;
	fp_js_group[j] <<
"[\"" << ctx->rw->class_name << "\",\"" << html_file_name << ".html\"]" << endl;
      }
    }
  }

  // Create class html file

  strcpy( fname, ctx->dir);
  strcat( fname, html_file_name);
  strcat( fname, ".html");
  cdh_ToLower( fname, fname);
  html_clf = new CnvFile();
  html_clf->f.open( fname);

  fp_tmp.open( cread_cTmpFile1);

  fp_tmp <<
"<HR><BR>" << endl <<
"<A NAME=\"detail\"><H1>Attributes detail</H1></A>" << endl;

  html_class_open = 1;

  html_clf->f <<
"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Frameset//EN\"\"http://www.w3.org/TR/REC-html40/frameset.dtd\">" << endl <<
"<!-- Generated by co_convert " << timestr << "  -->" << endl <<
"<HTML>" << endl <<
"<HEAD>" << endl <<
"<META http-equiv=\"Content-Type\" content=\"text/html; charset=ISO-8859-1\">" << endl <<
"<TITLE>" << endl <<
"  Class  " << full_class_name << endl <<
"</TITLE>" << endl <<
"<link rel=\"stylesheet\" type=\"text/css\" href=\"orm.css\">" << endl <<
"</HEAD>" << endl <<
"<BODY BGCOLOR=\"white\">" << endl <<
"" << endl <<
"<!-- ========== START OF NAVBAR ========== -->" << endl <<
"<A NAME=\"navbar_top\"><!-- --></A>" << endl <<
"<TABLE BORDER=\"0\" WIDTH=\"100%\" CELLPADDING=\"1\" CELLSPACING=\"0\">" << endl <<
"<TR>" << endl <<
"<TD COLSPAN=2 BGCOLOR=\"#EEEEFF\" CLASS=\"NavBarCell1\">" << endl <<
"<A NAME=\"navbar_top_firstrow\"><FONT  CLASS=\"NavBarFont1Rev\"><B>Volume " << ctx->rw->volume_name << "</B></FONT></A>" << endl <<
"</TD>" << endl <<
"</TR>" << endl <<
endl <<
"<TR>" << endl <<
"<TD BGCOLOR=\"white\" CLASS=\"NavBarCell2\"><FONT SIZE=\"-2\">" << endl <<
"  Attributes: &nbsp;<A HREF=\"#RtBody\">Runtime</A>" << endl <<
"&nbsp;|&nbsp;<A HREF=\"#DevBody\">Development</A>" << endl <<
"&nbsp;|&nbsp;<A HREF=\"#SysBody\">System</A>" << endl <<
"&nbsp;|&nbsp;<A HREF=\"#template\">Template</A>" << endl <<
"&nbsp;|&nbsp;<A HREF=\"#detail\">Detail</A>" << endl <<
"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;C Binding: " << endl <<
"&nbsp;<A HREF=\"" << struct_file << "#" << ctx->rw->class_name << "\">Struct</A>" << endl <<
"&nbsp;|&nbsp<A HREF=\"" << hpp_file << "#" << ctx->rw->class_name << "\">Class</A>" << endl;

  if ( ctx->rw->doc_fresh && strcmp( ctx->rw->doc_code, "") != 0) {
    if ( strstr( ctx->rw->doc_code, ".pdf") != 0) {
      strcpy( ref_name, ctx->rw->doc_code);
      html_clf->f <<
"&nbsp;|&nbsp;<A HREF=\"" << ref_name << "\">Code</A>" << endl;
    }
    else {
      CnvReadSrc::filename_to_html( ref_name, ctx->rw->doc_code);
      html_clf->f <<
"&nbsp;|&nbsp;<A HREF=\"" << ref_name << "#" << low_class_name << "\">Code</A>" << endl;
    }
  }
  html_clf->f <<
"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp<A HREF=\"" << ctree_file << "\">ClassTree</A>" << endl;

  html_clf->f <<
"</FONT></TD>" << endl <<
"<TD BGCOLOR=\"white\" CLASS=\"NavBarCell2\"><FONT SIZE=\"-2\">" << endl <<
"  <A HREF=\"" << low_volume_name << "_index.html\" TARGET=\"_top\"><B>INDEX</B></A>  &nbsp;" << endl <<
"&nbsp;<A HREF=\"" << html_file_name << ".html\" TARGET=\"_top\"><B>NO INDEX</B></A></FONT></TD>" << endl <<
"</TR>" << endl <<
"</TABLE>" << endl <<
"<!-- =========== END OF NAVBAR =========== -->" << endl <<
endl <<
"<HR>" << endl <<
"<!-- ======== START OF CLASS DATA ======== -->" << endl <<
"<H2>" << endl <<
"Class " << ctx->rw->class_name << "</H2>" << endl <<
"<HR>" << endl <<
"<DL>" << endl;
  if ( ctx->rw->doc_fresh && strcmp( ctx->rw->doc_author, "") != 0)
  {
    html_clf->f <<
"<DT><B>" << Lng::translate("Author") << "</B>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" << ctx->rw->doc_author << "<DT>" << endl;
  }

  if ( ctx->rw->doc_fresh && (strcmp( ctx->rw->doc_version, "") != 0 || 
			      strcmp( ctx->rw->class_version, "") != 0))
  {
    html_clf->f <<
"<DT><B>" << Lng::translate("Version") << "</B>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    if ( strcmp( ctx->rw->doc_version, "") != 0)
      html_clf->f << ctx->rw->doc_version << "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    if (strcmp( ctx->rw->class_version, "") != 0)
      html_clf->f << ctx->rw->class_version;
    html_clf->f << "<DT>" << endl;
  }
  if ( ctx->rw->doc_fresh && strcmp( ctx->rw->doc_code, "") != 0)
  {
    if ( strstr( ctx->rw->doc_code, ".pdf") != 0) {
      html_clf->f <<
"<DT><B>" << Lng::translate("Code") << "</B>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <A HREF=\"" << ref_name << "\"><FONT size=\"-1\">PlcTemplate</FONT></A><DT>" << endl;
    }
    else {
      html_clf->f <<
"<DT><B>" << Lng::translate("Code") << "</B>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <A HREF=\"" << ref_name << "#" << low_class_name << "\"><FONT size=\"-1\">" << ctx->rw->doc_code << "</FONT></A><DT>" << endl;
    }
  }

  html_clf->f <<
"<BR><DT><B>" << Lng::translate("Description") << "</B><DT><BR>" << endl <<
"</DL><DIV ID=\"description\"><XMP>" << endl;

  if ( ctx->rw->doc_fresh) {
    for ( i = 0; i < ctx->rw->doc_cnt; i++) {
      ctx->remove_spaces( ctx->rw->doc_text[i], txt);
      if ( strncmp( CnvCtx::low(txt), "@image", 6) == 0)  {
	char imagefile[80];

	ctx->remove_spaces( txt + 6, imagefile);
	html_clf->f << "</XMP><IMG SRC=\"" << imagefile << "\"><XMP>" << endl;
      }
      else if ( strncmp( CnvCtx::low(txt), "@b", 2) == 0)  {
	html_clf->f << "</XMP><B><FONT SIZE=\"3\">" << txt + 2 << "</FONT></B><XMP>" << endl;
      }
      else if ( strncmp( CnvCtx::low(txt), "@h1", 3) == 0)  {
	html_clf->f << "</XMP><H3>" << txt + 3 << "</H3><XMP>" << endl;
      }
      else if ( strncmp( CnvCtx::low(txt), "@h2", 3) == 0)  {
	html_clf->f << "</XMP><H4>" << txt + 3 << "</H4><XMP>" << endl;
      }
      else
	html_clf->f << ctx->rw->doc_text[i] << endl;
    }
  }
  html_clf->f <<
"</XMP>" << endl;

  for ( i = 0; i < ctx->rw->doc_xlink_cnt; i++) {
    html_clf->f <<
"  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<A HREF=\"" << ctx->rw->doc_xlink_ref[i] << "\" TARGET=\"_self\"><FONT size=\"-1\"> " << ctx->rw->doc_xlink_text[i] <<"</FONT></A><BR>" << endl;
  }
  for ( i = 0; i < ctx->rw->doc_clink_cnt; i++) {
    html_clf->f <<
"  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<A HREF=\"" << ctx->rw->doc_clink_ref[i] << "\" TARGET=\"_self\"><FONT size=\"-1\"> " << ctx->rw->doc_clink_text[i] <<"</FONT></A><BR>" << endl;
  }
  for ( i = 0; i < ctx->rw->doc_link_cnt; i++) {
    html_clf->f <<
"  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<A HREF=\"" << ctx->rw->doc_link_ref[i] << "\" TARGET=\"_self\"><FONT size=\"-1\"> " << ctx->rw->doc_link_text[i] <<"</FONT></A><BR>" << endl;
  }
  html_clf->f <<
"</DIV>" << endl;  
  return 1;
}

int CnvWblToHtml::body_exec()
{
  char struct_name[80];
  pwr_tFileName fname;
  pwr_tFileName struct_file;

  CnvWblToH::get_filename( ctx->rw, fname, 0);
  CnvReadSrc::filename_to_html( struct_file, fname);

  if ( strcmp( CnvCtx::low(ctx->rw->body_name), "devbody") == 0)
    strcpy( struct_name, "");
  else
  {
    strcpy( struct_name, "pwr_sClass_");
    if ( strcmp( ctx->rw->body_structname, "") == 0)
      strcat( struct_name, ctx->rw->class_name);
    else
      strcat( struct_name, ctx->rw->body_structname);
  }

  html_clf->f <<
"<!-- =========== BODY =========== -->" << endl <<
endl <<
"<HR><BR>" << endl <<
"<A NAME=\"" << ctx->rw->body_name << "\"><!-- --></A>" << endl <<
"<TABLE BORDER=\"1\" CELLPADDING=\"3\" CELLSPACING=\"0\" WIDTH=\"100%\">" << endl <<
"<TR BGCOLOR=\"#CCCCFF\" CLASS=\"TableHeadingColor\">" << endl <<
"<TD COLSPAN=4><FONT SIZE=\"+2\">" << endl <<
"<B>" << ctx->rw->body_name << " attributes</B></FONT>" <<
"<FONT SIZE=\"+1\"<B>&nbsp;&nbsp;&nbsp;&nbsp; <A HREF=\"" << struct_file << "#" << ctx->rw->class_name << "\">" << struct_name << "</A></B></FONT></TD>" << endl <<
"</TR>" << endl;

  return 1;
}

int CnvWblToHtml::body_close()
{
  html_clf->f <<
"</TABLE>" << endl;

  return 1;
}

int CnvWblToHtml::graphplcnode()
{
  int i;

  html_clf->f <<
"<!-- =========== GRAPHPLCNODE =========== -->" << endl <<
endl <<
"<HR><BR>" << endl <<
"<A NAME=\"GraphPlcNode\"><!-- --></A>" << endl <<
"<TABLE BORDER=\"1\" CELLPADDING=\"3\" CELLSPACING=\"0\" WIDTH=\"100%\">" << endl <<
"<TR BGCOLOR=\"#CCCCFF\" CLASS=\"TableHeadingColor\">" << endl <<
"<TD COLSPAN=2><FONT SIZE=\"+2\">" << endl <<
"<B>" << ctx->rw->graphplcnode_name << "</B></FONT></TD>" << endl <<
"</TR>" << endl;

  for ( i = 0; i < ctx->rw->doc_cnt; i += 2)
  {
    html_clf->f <<
"<TR BGCOLOR=\"white\" CLASS=\"TableRowColor\">" << endl <<
"<TD><CODE><B>" << ctx->rw->doc_text[i] << "</B></CODE></TD>" << endl <<
"<TD><CODE>" << ctx->rw->doc_text[i+1] << "</CODE></TD>" << endl;
  }
  html_clf->f << "</TABLE>" << endl;

  return 1;
}

int CnvWblToHtml::graphplccon()
{
  int i;

  html_clf->f <<
"<!-- =========== GRAPHPLCCON =========== -->" << endl <<
endl <<
"<HR><BR>" << endl <<
"<TABLE BORDER=\"1\" CELLPADDING=\"3\" CELLSPACING=\"0\" WIDTH=\"100%\">" << endl <<
"<TR BGCOLOR=\"#CCCCFF\" CLASS=\"TableHeadingColor\">" << endl <<
"<TD COLSPAN=2><FONT SIZE=\"+2\">" << endl <<
"<B>" << ctx->rw->graphplccon_name << "</B></FONT></TD>" << endl <<
"</TR>" << endl;

  for ( i = 0; i < ctx->rw->doc_cnt; i += 2)
  {
    html_clf->f <<
"<TR BGCOLOR=\"white\" CLASS=\"TableRowColor\">" << endl <<
"<TD><CODE><B>" << ctx->rw->doc_text[i] << "</B></CODE></TD>" << endl <<
"<TD><CODE>" << ctx->rw->doc_text[i+1] << "</CODE></TD>" << endl;
  }
  html_clf->f << "</TABLE>" << endl;

  return 1;
}

int CnvWblToHtml::template_exec()
{
  int i;

  if ( !html_class_open)
    return 1;

  html_clf->f <<
"<!-- =========== TEMPLATE =========== -->" << endl <<
endl <<
"<HR><BR>" << endl <<
"<A NAME=\"template\"><!-- --></A>" << endl <<
"<TABLE BORDER=\"1\" CELLPADDING=\"3\" CELLSPACING=\"0\" WIDTH=\"100%\">" << endl <<
"<TR BGCOLOR=\"#CCCCFF\" CLASS=\"TableHeadingColor\">" << endl <<
"<TD COLSPAN=2><FONT SIZE=\"+2\">" << endl <<
"<B>Template Object</B></FONT></TD>" << endl <<
"</TR>" << endl;

  for ( i = 0; i < ctx->rw->doc_cnt; i += 2)
  {
    html_clf->f <<
"<TR BGCOLOR=\"white\" CLASS=\"TableRowColor\">" << endl <<
"<TD><CODE><B>" << ctx->rw->doc_text[i] << "</B></CODE></TD>" << endl <<
"<TD><CODE>" << ctx->rw->doc_text[i+1] << "</CODE></TD>" << endl;
  }
  html_clf->f << "</TABLE>" << endl;

  return 1;
}

int CnvWblToHtml::class_close()
{
  fp_tmp.close();

  // Copy temporary file
  ctx->rw->copy_tmp_file( cread_cTmpFile1, html_clf->f);

  html_clf->f <<
"<!-- ========= END OF CLASS DATA ========= -->" << endl <<
"</BODY>" << endl <<
"</HTML>" << endl;

  html_clf->f.close();
  delete html_clf;

  html_class_open = 0;

  if ( !cdp_created) {
    create_cdp_file( ctx->rw->volume_name, ctx->rw->class_name, "-");
    cdp_created = true;
  }
  return 1;
}

// Create class dependency file
void CnvWblToHtml::create_cdp_file( const char *volume_name, const char *class_name, 
				    const char *attr_typeref)
{
  pwr_tFileName fname;

  sprintf( fname, "$pwre_broot/$pwre_target/bld/wbl/%s.cdp", CnvCtx::low(class_name));
  dcli_translate_filename( fname, fname);
  
  ofstream fp( fname);
  fp << volume_name << " " << class_name << " " << attr_typeref << endl;
}

int CnvWblToHtml::attribute_exec()
{
  int i;
  char txt[200];
  char typeref_href[80];
  char attrtype_href[80];
  int lng_sts = 1;

  if ( strcmp( CnvCtx::low( ctx->rw->attr_name), "super") == 0) {
    create_cdp_file( ctx->rw->volume_name, ctx->rw->class_name, ctx->rw->attr_typeref);
    cdp_created = true;
  }

  if ( strcmp( ctx->rw->attr_typeref, "CastId") == 0 ||
       strcmp( ctx->rw->attr_typeref, "DisableAttr") == 0)
    return 1;
    
  if ( Lng::current() != lng_eLanguage_en_US)
    lng_sts = ctx->rw->read_lng( ctx->rw->class_name, ctx->rw->attr_name);

  if ( strncmp( ctx->rw->attr_typeref, "pwr_eClass_", 11)  == 0) {
    strcpy( typeref_href, &ctx->rw->attr_typeref[11]);
    strcpy( ctx->rw->attr_typeref, typeref_href);    
  }
  else if ( strncmp( ctx->rw->attr_typeref, "pwr_eType_", 10)  == 0) {
    strcpy( typeref_href, &ctx->rw->attr_typeref[10]);
    strcpy( ctx->rw->attr_typeref, typeref_href);
  }
  else if ( strncmp( ctx->rw->attr_typeref, "pwr_eTypeDef_", 13)  == 0) {
    strcpy( typeref_href, &ctx->rw->attr_typeref[13]);
    strcpy( ctx->rw->attr_typeref, typeref_href);
  }
  if ( strcmp( ctx->rw->attr_typeref_volume, "") != 0) {
    char low_volname[80];
    strcpy( low_volname, CnvCtx::low(ctx->rw->attr_typeref_volume)); 
    sprintf( typeref_href, "%s_%s.html", low_volname,
	     CnvCtx::low(ctx->rw->attr_typeref));
  }
  else
    sprintf( typeref_href, "pwrs_%s.html", CnvCtx::low(ctx->rw->attr_typeref));

  sprintf( attrtype_href, "pwrs_%s.html", CnvCtx::low(ctx->rw->attr_type));

  // Summary

  html_clf->f <<
"<TR BGCOLOR=\"white\" CLASS=\"TableRowColor\">" << endl <<
"<TD ALIGN=\"right\" VALIGN=\"top\" WIDTH=\"1%\"><FONT SIZE=\"-1\">" << endl <<
"<A HREF=\"" << typeref_href << "\">";
  
  if ( ctx->rw->attr_array && ctx->rw->attr_pointer)
    html_clf->f <<
"<CODE>Array of pointers to "<< ctx->rw->attr_typeref << "</CODE></FONT></A></TD>" << endl;
  else if ( ctx->rw->attr_array)
    html_clf->f <<
"<CODE>Array of "<< ctx->rw->attr_typeref << "</CODE></FONT></A></TD>" << endl;
  else if ( ctx->rw->attr_pointer)
    html_clf->f <<
"<CODE>Pointer to " << ctx->rw->attr_typeref << "</CODE></FONT></A></TD>" << endl;
  else
    html_clf->f <<
"<CODE>" << ctx->rw->attr_typeref << "</CODE></FONT></A></TD>" << endl;

  html_clf->f <<
"</A><TD><A HREF=\"#" << ctx->rw->attr_name << "\"><CODE><B>" << ctx->rw->attr_name << "</B></CODE></A></TD>" << endl;
  if ( strcmp( ctx->rw->attr_graphname, "") != 0 )
    html_clf->f <<
"<TD WIDTH=\"1%\">" << ctx->rw->attr_graphname << "</TD>" << endl;
  else
    html_clf->f <<
"<TD WIDTH=\"1%\">&nbsp;</TD>" << endl;
  html_clf->f <<
"<TD>";
  if ( ctx->rw->doc_fresh)
  {
    if ( strcmp( ctx->rw->doc_summary, "") == 0) 
    {
      for ( i = 0; i < ctx->rw->doc_cnt; i++) {
	ctx->remove_spaces( ctx->rw->doc_text[i], txt);
	if ( strncmp( CnvCtx::low(txt), "@image", 6) == 0) {
	  continue;
	}
	else if ( strncmp( CnvCtx::low(txt), "@b", 2) == 0)  {
	  html_clf->f << "</XMP><B><FONT SIZE=\"3\">" << txt + 2 << "</FONT></B><XMP>" << endl;
	}
	else if ( strncmp( CnvCtx::low(txt), "@h1", 3) == 0)  {
	  html_clf->f << "<H3>" << txt + 3 << "</H3>" << endl;
	}
	else if ( strncmp( CnvCtx::low(txt), "@h2", 3) == 0)  {
	  html_clf->f << "<H4>" << txt + 3 << "</H4>" << endl;
	}
	else {
	  html_clf->f << ctx->rw->doc_text[i];
	  if ( i < ctx->rw->doc_cnt - 1)
	    html_clf->f << "<BR>" << endl;
	}
      }
    }
    else
      html_clf->f << ctx->rw->doc_summary << endl;
  }
  else
    html_clf->f << "<BR>" << endl;

  html_clf->f <<
"</TD>" << endl;


  // Detail

  fp_tmp <<
"<HR>" << endl <<
"<A NAME=\"" << ctx->rw->attr_name << "\"> <H3>" <<
"<FONT SIZE=\"-1\">" << ctx->rw->attr_type << "</FONT> " << ctx->rw->attr_name << "</H3></A>" << endl <<
    "<DL><DT>" << endl;

  if ( ctx->rw->attr_array && ctx->rw->attr_pointer)
    fp_tmp <<
"<CODE><B>" << Lng::translate("Type") << "</B>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Array of pointers to <A HREF=\"" << typeref_href << "\">" << ctx->rw->attr_typeref << "</A></CODE><DT>" << endl;
  else if ( ctx->rw->attr_array)
    fp_tmp <<
"<CODE><B>" << Lng::translate("Type") << "</B>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Array of <A HREF=\"" << typeref_href << "\">" << ctx->rw->attr_typeref << "</A></CODE><DT>" << endl;
  else if ( ctx->rw->attr_pointer)
    fp_tmp <<
"<CODE><B>" << Lng::translate("Type") << "</B>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Pointer to <A HREF=\"" << typeref_href << "\">" << ctx->rw->attr_typeref << "</A></CODE><DT>" << endl;
  else
    fp_tmp <<
"<CODE><B>" << Lng::translate("Type") << "</B>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<A HREF=\"" << typeref_href << "\">" << ctx->rw->attr_typeref << "</A></CODE><DT>" << endl;

  fp_tmp <<
    "<DT><CODE><B><A HREF=\"" << attrtype_href << "#Flags\">Flags</A></B>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" << ctx->rw->attr_flags << "</CODE><DT>" << endl;

  if ( ctx->rw->attr_array)
    fp_tmp <<
"<DT><CODE><B>Elements</B>&nbsp;&nbsp;" << ctx->rw->attr_elements << "</CODE><DT>" << endl;

  if ( strcmp( ctx->rw->attr_graphname, "") != 0)
    fp_tmp <<
"<DT><CODE><B>GraphName</B>&nbsp;" << ctx->rw->attr_graphname << "</CODE><DT>" << endl;

  fp_tmp <<
"<DT><CODE><B>" << Lng::translate("Body") << "</B>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" << ctx->rw->body_name << "</CODE><DT>" << endl;
  fp_tmp <<
"<DT><CODE><B>" << Lng::translate("Class") << "</B>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<A HREF=\"" << attrtype_href << "\">$" << ctx->rw->attr_type << "</A></CODE><DT>" << endl;

  fp_tmp <<
"<BR>" << endl <<
"<CODE><B>" << Lng::translate("Description") << "</B></CODE><DT></DL>" << endl <<
"<DIV ID=\"description\"><XMP>" << endl;

  if ( ctx->rw->doc_fresh) {
    for ( i = 0; i < ctx->rw->doc_cnt; i++) {
      ctx->remove_spaces( ctx->rw->doc_text[i], txt);
      if ( strncmp( CnvCtx::low(txt), "@image", 6) == 0)  {
	char imagefile[80];

	ctx->remove_spaces( txt + 6, imagefile);
	fp_tmp << "</XMP><IMG SRC=\"" << imagefile << "\"><XMP>" << endl;
      }
      else if ( strncmp( CnvCtx::low(txt), "@b", 2) == 0)  {
	fp_tmp << "</XMP><B><FONT SIZE=\"3\">" << txt + 2 << "</FONT></B><XMP>" << endl;
      }
      else if ( strncmp( CnvCtx::low(txt), "@h1", 3) == 0)  {
	fp_tmp << "</XMP><H3>" << txt + 3 << "</H3><XMP>" << endl;
      }
      else if ( strncmp( CnvCtx::low(txt), "@h2", 3) == 0)  {
	fp_tmp << "</XMP><H4>" << txt + 3 << "</H4><XMP>" << endl;
      }
      else
	fp_tmp << ctx->rw->doc_text[i] << endl;
    }
  }
  fp_tmp <<
"</XMP></DIV>" << endl;

  return 1;
}


int CnvWblToHtml::bit_exec()
{
  int i;
  char txt[200];
  int lng_sts = 1;

  if ( Lng::current() != lng_eLanguage_en_US)
    lng_sts = ctx->rw->read_lng( ctx->rw->typedef_name, ctx->rw->bit_name);

  // Summary
  char bitchar = _tolower(ctx->rw->typedef_typeref[0]);

  html_clf->f <<
"<TR BGCOLOR=\"white\" CLASS=\"TableRowColor\">" << endl <<
"<TD>" << endl <<
"<CODE><FONT SIZE=\"-1\">pwr_" << bitchar << ctx->rw->typedef_name << "_" << ctx->rw->bit_pgmname << "</FONT></CODE></TD>" << endl <<
"<TD ALIGN =\"right\" VALIGN=\"top\" WIDTH=\"1%\"><A HREF=\"#" << ctx->rw->bit_name << "\"><CODE><B>" << ctx->rw->bit_text << "</B></CODE></A></TD>" << endl <<
"<TD>";
  if ( ctx->rw->doc_fresh)
  {
    if ( strcmp( ctx->rw->doc_summary, "") == 0) 
    {
      for ( i = 0; i < ctx->rw->doc_cnt; i++) {
	ctx->remove_spaces( ctx->rw->doc_text[i], txt);
	if ( strncmp( CnvCtx::low(txt), "@image", 6) == 0) {
	  continue;
	}
	else if ( strncmp( CnvCtx::low(txt), "@b", 2) == 0)  {
	  html_clf->f << "</XMP><B><FONT SIZE=\"3\">" << txt + 2 << "</FONT></B><XMP>" << endl;
	}
	else if ( strncmp( CnvCtx::low(txt), "@h1", 3) == 0)  {
	  html_clf->f << "<H3>" << txt + 3 << "</H3>" << endl;
	}
	else if ( strncmp( CnvCtx::low(txt), "@h2", 3) == 0)  {
	  html_clf->f << "<H4>" << txt + 3 << "</H4>" << endl;
	}
	else {
	  html_clf->f << ctx->rw->doc_text[i];
	  if ( i < ctx->rw->doc_cnt - 1)
	    html_clf->f << "<BR>" << endl;
	}
      }
    }
    else
      html_clf->f << ctx->rw->doc_summary << endl;
  }
  else
    html_clf->f << "<BR>" << endl;

  html_clf->f <<
"</TD>" << endl;


  // Detail

  fp_tmp <<
"<HR>" << endl <<
"<A NAME=\"" << ctx->rw->bit_name << "\"> <H3>" <<
    "<FONT SIZE=\"-1\">pwr_" << bitchar << ctx->rw->typedef_name << "_" << ctx->rw->bit_pgmname << "</FONT>&nbsp;&nbsp;" << ctx->rw->bit_text << "</H3></A>" << endl <<
"<DL><DT>" << endl <<
"<CODE><B>Value</B>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" << ctx->rw->bit_value << "</CODE><DT>" << endl;

  fp_tmp <<
"<BR>" << endl <<
"<CODE><B>Description</B></CODE><DT></DL>" << endl <<
"<DIV ID=\"description\"><XMP>" << endl;

  if ( ctx->rw->doc_fresh) {
    for ( i = 0; i < ctx->rw->doc_cnt; i++) {
      ctx->remove_spaces( ctx->rw->doc_text[i], txt);
      if ( strncmp( CnvCtx::low(txt), "@image", 6) == 0)  {
	char imagefile[80];

	ctx->remove_spaces( txt + 6, imagefile);
	fp_tmp << "</XMP><IMG SRC=\"" << imagefile << "\"><XMP>" << endl;
      }
      else if ( strncmp( CnvCtx::low(txt), "@b", 2) == 0)  {
	fp_tmp << "</XMP><B><FONT SIZE=\"3\">" << txt + 2 << "</FONT></B><XMP>" << endl;
      }
      else if ( strncmp( CnvCtx::low(txt), "@h1", 3) == 0)  {
	fp_tmp << "</XMP><H3>" << txt + 3 << "</H3><XMP>" << endl;
      }
      else if ( strncmp( CnvCtx::low(txt), "@h2", 3) == 0)  {
	fp_tmp << "</XMP><H4>" << txt + 3 << "</H4><XMP>" << endl;
      }
      else
	fp_tmp << ctx->rw->doc_text[i] << endl;
    }
  }
  fp_tmp <<
"</XMP></DIV>" << endl;

  return 1;
}


int CnvWblToHtml::typedef_exec()
{
  pwr_tFileName fname;
  int i;
  pwr_tFileName html_file_name;
  char full_class_name[80];
  char ref_name[200];
  pwr_tFileName struct_file;
  char low_volume_name[80];
  char low_class_name[80];
  char txt[200];
  char code_aref[200];
  int lng_sts = 1;

  if ( Lng::current() != lng_eLanguage_en_US)
    lng_sts = ctx->rw->read_lng( ctx->rw->typedef_name, 0);

  strcpy( ctx->rw->class_name, ctx->rw->typedef_name);

  cdh_ToLower( low_volume_name, ctx->rw->volume_name);
  cdh_ToLower( low_class_name, ctx->rw->class_name);

  CnvWblToH::get_filename( ctx->rw, fname, 0);
  CnvReadSrc::filename_to_html( struct_file, fname);

  strcpy( full_class_name, ctx->rw->volume_name);
  strcat( full_class_name, ":");
  strcat( full_class_name, ctx->rw->class_name);

  strcpy( html_file_name, low_volume_name);
  strcat( html_file_name, "_");
  strcat( html_file_name, low_class_name);

  // Add into index file
  fp_html_index <<
"<A HREF=\"" << html_file_name << ".html\" TARGET=\"classFrame\">" << ctx->rw->class_name << "</A>" << endl <<
"<BR>" << endl;

  // Add into AllClasses js file
  cnv_mentry mentry;
  strcpy( mentry.name, ctx->rw->class_name);
  strcpy( mentry.file, html_file_name);
  strcat( mentry.file, ".html");
  all_types.push_back( mentry);

  // Add into group file
  for ( int i = 0; i < ctx->rw->doc_group_cnt; i++) {
    for ( int j = 0; j < ctx->setup->group_cnt; j++) {
      if ( cdh_NoCaseStrcmp( ctx->rw->doc_groups[i], ctx->setup->groups[j]) == 0) {
	fp_html_group[j] <<
"<A HREF=\"" << html_file_name << ".html\" TARGET=\"classFrame\">" << ctx->rw->class_name << "</A>" << endl <<
"<BR>" << endl;

 	if ( !js_group_first[j])
	  fp_js_group[j] << ",";
	else
	  js_group_first[j] = false;

	fp_js_group[j] <<
"[\"" << ctx->rw->class_name << "\",\"" << html_file_name << ".html\"]" << endl;
      }
    }
  }

  // Create class html file

  strcpy( fname, ctx->dir);
  strcat( fname, html_file_name);
  strcat( fname, ".html");
  cdh_ToLower( fname, fname);
  html_clf = new CnvFile();
  html_clf->f.open( fname);

  fp_tmp.open( cread_cTmpFile1);


  html_class_open = 1;

  html_clf->f <<
"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Frameset//EN\"\"http://www.w3.org/TR/REC-html40/frameset.dtd\">" << endl <<
"<!-- Generated by pwr_cnv-->" << endl <<
"<HTML>" << endl <<
"<HEAD>" << endl <<
"<META http-equiv=\"Content-Type\" content=\"text/html; charset=ISO-8859-1\">" << endl <<
"<TITLE>" << endl <<
": Type  " << full_class_name << endl <<
"</TITLE>" << endl <<
"<link rel=\"stylesheet\" type=\"text/css\" href=\"orm.css\">" << endl <<
"</HEAD>" << endl <<
"<BODY BGCOLOR=\"white\">" << endl <<
"" << endl <<
"<!-- ========== START OF NAVBAR ========== -->" << endl <<
"<A NAME=\"navbar_top\"><!-- --></A>" << endl <<
"<TABLE BORDER=\"0\" WIDTH=\"100%\" CELLPADDING=\"1\" CELLSPACING=\"0\">" << endl <<
"<TR>" << endl <<
"<TD COLSPAN=2 BGCOLOR=\"#EEEEFF\" CLASS=\"NavBarCell1\">" << endl <<
"<A NAME=\"navbar_top_firstrow\"><FONT  CLASS=\"NavBarFont1Rev\"><B>Volume " << ctx->rw->volume_name << "</B></FONT></A>" << endl <<
"</TD>" << endl <<
"</TR>" << endl <<
endl <<
"<TR>" << endl <<
"<TD BGCOLOR=\"white\" CLASS=\"NavBarCell2\"><FONT SIZE=\"-2\">" << endl;

  if ( (strcmp( ctx->rw->typedef_typeref, "Mask") == 0 ||
	strcmp( ctx->rw->typedef_typeref, "Enum") == 0) &&
       strcmp( low_volume_name, "pwrs") != 0) {
    sprintf( code_aref, "%s#%s", struct_file, ctx->rw->typedef_name);
    html_clf->f <<
" C Binding: &nbsp;<A HREF=\"" << code_aref << "\">Typedef</A>" << endl;
  }
  else if ( ctx->rw->doc_fresh && strcmp( ctx->rw->doc_code, "") != 0)
  {
    CnvReadSrc::filename_to_html( ref_name, ctx->rw->doc_code);
    sprintf( code_aref, "%s#%s", ref_name, low_class_name);
    html_clf->f <<
" C Binding: &nbsp;<A HREF=\"" << code_aref << "\">Typedef</A>" << endl;
  }
  for ( i = 0; i < 50; i++)
    html_clf->f << "&nbsp;";
  html_clf->f <<
"</FONT></TD>" << endl <<
"<TD BGCOLOR=\"white\" CLASS=\"NavBarCell2\"><FONT SIZE=\"-2\">" << endl <<
"  <A HREF=\"" << low_volume_name << "_index.html\" TARGET=\"_top\"><B>INDEX</B></A>  &nbsp;" << endl <<
"&nbsp;<A HREF=\"" << html_file_name << ".html\" TARGET=\"_top\"><B>NO INDEX</B></A></FONT></TD>" << endl <<
"</TR>" << endl <<
"</TABLE>" << endl <<
"<!-- =========== END OF NAVBAR =========== -->" << endl <<
endl <<
"<HR>" << endl <<
"<!-- ======== START OF CLASS DATA ======== -->" << endl <<
"<H2>" << endl <<
"Type " << ctx->rw->class_name << "</H2>" << endl <<
"<HR>" << endl <<
"<DL>" << endl;
  if ( ctx->rw->doc_fresh && strcmp( ctx->rw->doc_author, "") != 0)
  {
    html_clf->f <<
"<DT><B>Author</B>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" << ctx->rw->doc_author << "<DT>" << endl;
  }

  if ( ctx->rw->doc_fresh && strcmp( ctx->rw->doc_version, "") != 0)
  {
    html_clf->f <<
"<DT><B>Version</B>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" << ctx->rw->doc_version << "<DT>" << endl;
  }
  if ( ctx->rw->doc_fresh && strcmp( ctx->rw->doc_code, "") != 0)
  {
    html_clf->f <<
"<DT><B>Code</B>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" << ctx->rw->doc_code << "<DT>" << endl;
  }

  html_clf->f <<
"<BR><DT><B>Description</B><DT><BR>" << endl <<
"</DL><DIV ID=\"description\"><XMP>" << endl;

  if ( ctx->rw->doc_fresh) {
    for ( i = 0; i < ctx->rw->doc_cnt; i++) {
      ctx->remove_spaces( ctx->rw->doc_text[i], txt);
      if ( strncmp( CnvCtx::low(txt), "@image", 6) == 0)  {
	char imagefile[80];

	ctx->remove_spaces( txt + 6, imagefile);
	html_clf->f << "</XMP><IMG SRC=\"" << imagefile << "\"><XMP>" << endl;
      }
      else if ( strncmp( CnvCtx::low(txt), "@b", 2) == 0)  {
	html_clf->f << "</XMP><B><FONT SIZE=\"3\">" << txt + 2 << "</FONT></B><XMP>" << endl;
      }
      else if ( strncmp( CnvCtx::low(txt), "@h1", 3) == 0)  {
	html_clf->f << "</XMP><H3>" << txt + 3 << "</H3><XMP>" << endl;
      }
      else if ( strncmp( CnvCtx::low(txt), "@h2", 3) == 0)  {
	html_clf->f << "</XMP><H4>" << txt + 3 << "</H4><XMP>" << endl;
      }
      else
	html_clf->f << ctx->rw->doc_text[i] << endl;
    }
  }
  html_clf->f <<
"</XMP></DIV>" << endl;

  for ( i = 0; i < ctx->rw->doc_link_cnt; i++) {
    html_clf->f <<
"  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<A HREF=\"" << ctx->rw->doc_link_ref[i] << "\" TARGET=\"_self\"><FONT size=\"-1\"> " << ctx->rw->doc_link_text[i] <<"</FONT></A><BR>" << endl;
  }
  for ( i = 0; i < ctx->rw->doc_clink_cnt; i++) {
    html_clf->f <<
"  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<A HREF=\"" << ctx->rw->doc_clink_ref[i] << "\" TARGET=\"_self\"><FONT size=\"-1\"> " << ctx->rw->doc_clink_text[i] <<"</FONT></A><BR>" << endl;
  }
  html_clf->f <<
"</FONT>" << endl;


  if ( strcmp( ctx->rw->typedef_typeref, "Mask") == 0 ||
       strcmp( ctx->rw->typedef_typeref, "Enum") == 0) {
    char bitchar = _tolower(ctx->rw->typedef_typeref[0]);

    html_clf->f <<
"<HR><BR>" << endl <<
"<A NAME=\"" << ctx->rw->typedef_name << "\"><!-- --></A>" << endl <<
"<TABLE BORDER=\"1\" CELLPADDING=\"3\" CELLSPACING=\"0\" WIDTH=\"100%\">" << endl <<
"<TR BGCOLOR=\"#CCCCFF\" CLASS=\"TableHeadingColor\">" << endl <<
"<TD COLSPAN=3><FONT SIZE=\"+2\">" << endl <<
"<B>" << ctx->rw->typedef_name << " elements</B></FONT>" <<
"<FONT SIZE=\"+1\"<B>&nbsp;&nbsp;&nbsp;&nbsp; <A HREF=\"" << code_aref << "\">pwr_" << bitchar << ctx->rw->typedef_name << "</A></B></FONT></TD>" << endl <<
"</TR>" << endl;
  }
  return 1;
}

int CnvWblToHtml::typedef_close()
{
  if ( strcmp( ctx->rw->typedef_typeref, "Mask") == 0 ||
       strcmp( ctx->rw->typedef_typeref, "Enum") == 0) {
  html_clf->f <<
"</TABLE>" << endl;
  }

  fp_tmp.close();

  // Copy temporary file
  ctx->rw->copy_tmp_file( cread_cTmpFile1, html_clf->f);

  html_clf->f <<
"<!-- ========= END OF CLASS DATA ========= -->" << endl <<
"</BODY>" << endl <<
"</HTML>" << endl;

  html_clf->f.close();
  delete html_clf;

  html_class_open = 0;

  return 1;
}



void CnvWblToHtml::print_all_menu()
{
  // Sort
  if ( all_types.size()) {
    for ( unsigned int i = all_types.size() - 1; i > 0; i--) {
      for ( unsigned int j = 0; j < i; j++) {
	if ( !(all_types[j] < all_types[j+1])) {
	  cnv_mentry mi = all_types[j+1];
	  all_types[j+1] = all_types[j];
	  all_types[j] = mi;
	}
      }
    }
  }
  if ( all_classes.size()) {
    for ( unsigned int i = all_classes.size() - 1; i > 0; i--) {
      for ( unsigned int j = 0; j < i; j++) {
	if ( !(all_classes[j] < all_classes[j+1])) {
	  cnv_mentry mi = all_classes[j+1];
	  all_classes[j+1] = all_classes[j];
	  all_classes[j] = mi;
	}
      }
    }
  }

  for ( unsigned int i = 0; i < all_types.size(); i++) {

    // Add into AllClasses js file
    if ( !js_all_first)
      fp_js_all << ",";
    else
      js_all_first = false;
      
    fp_js_all <<
      "[\"" << all_types[i].name << "\",\"" << all_types[i].file << "\"]" << endl;
  }

  for ( unsigned int i = 0; i < all_classes.size(); i++) {

    // Add into AllClasses js file
    if ( !js_all_first)
      fp_js_all << ",";
    else
      js_all_first = false;
      
    fp_js_all <<
      "[\"" << all_classes[i].name << "\",\"" << all_classes[i].file << "\"]" << endl;
  }
}



